// Chargement du fichier contenant les donnes (La commande + la rponse)

loadmatfile(format="-ascii",'Test.txt');  // Charge le fichier
Y=Test(:,2);                              // Isole la rponse
U=Test(:,1);                              // Isole la commande
//Y=data(:,4);                              // Isole la rponse
//U=data(:,3);                              // Isole la commande

N=size(Y,1);                              // Mesure le nombre d'chantillons

// Affichage des courbes 

plot (U,'r');
plot (Y);
xlabel ("Temps (multiple de la priode d chantillonage : n)"); 
legend ("Commande U(n)","Rponse Y(n)");

// Modlisation par la mthode des moindres carrs 

S1=0;     // Initialise les sommes
S2=0;
S3=0;
S4=0;
S5=0;
for i=1:N-1, 
  S1=S1+Y(i)*Y(i);     // Calcule chacune des sommes
  S2=S2+U(i)*Y(i);
  S3=S3+U(i)*U(i);
  S4=S4+Y(i)*Y(i+1);
  S5=S5+U(i)*Y(i+1);
end
a=(S3*S4-S2*S5)/(S1*S3-S2*S2); // Calcule des coefficient
b=(S1*S5-S2*S4)/(S1*S3-S2*S2);

disp a;
disp b;
// Calcule la rponse du modle en fonction de la commande U

Ym=0;
for i=1:N-1, 
  Ym(i+1)=a*Ym(i)+b*U(i);
end
plot (Ym,'g');

K=(1-a)/b;

//K=2;
//a=0.5;


Kp=((1-a)/b);
Ki=Kp-a*Kp;

xset('window',1);// affiche la nouvelle fenetre




e=0; u=0; y=0; ypid=0;
ypid(1)=0;
y(1)=0;
e(1)=0;
u(1)=0;
Error(i)=0;
for i=1:650

    e(i+1)=10;

    Error(i+1)=e(i+1)-ypid(i);
    u(i+1)=u(i)+K*Error(i+1)-a*K*Error(i);
//     u(i+1)=u(i)+(Ki-Kp)*Error(i)+Kp*Error(i+1);
    if (u(i+1)>1024) u(i+1)=1024; end;
    if (u(i+1)<-1024) u(i+1)=-1024; end;    
    ypid(i+1)=a*ypid(i)+b*u(i+1);
    y(i+1)=a*y(i)+b*e(i+1);
    
end
//figure(2);
plot (e,'r');
plot (u,'k');
plot (ypid,'g');
plot (y,'m');

legend ("Consigne e(n)","Commande U(n)","Sortie BF Y(n)","Sortie BO Y(n)");

